<?php
//This variable specifies relative path to the folder, where the gallery with uploaded files is located.
//Do not forget about the slash in the end of the folder name.
$galleryPath = "../Gallery/";

$absGalleryPath = realpath($galleryPath) . "/";
$absThumbnailsPath = realpath($galleryPath . "Thumbnails/") . "/";

function saveUploadedFiles()
{
	global $absGalleryPath, $absThumbnailsPath;
	
	//Get the source file and save it to disk. 
    
	//NOTE: Since each file is uploaded in a separate request (because 
	//FilesPerOnePackageCount param equals to 1), you should work only 
	//with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc). 
	if (!$_FILES["SourceFile_1"]['size'])
	{
		return;	
	}
	$fileName = getSafeFileName($_FILES["SourceFile_1"]['name']);
	move_uploaded_file($_FILES["SourceFile_1"]['tmp_name'], $absGalleryPath . "/" . $fileName);

	//Get the thumbnail and save it to disk.
	if (!$_FILES["Thumbnail1_1"]['size'])
	{
		return;	
	}
	move_uploaded_file($_FILES["Thumbnail1_1"]['tmp_name'], $absGalleryPath . "/Thumbnails/" . $fileName . ".jpg");

	//Get file info and save it to XML file.
	//NOTE: In this demo this file is used by different upload threads asynchronously. That's why 
	//it is necessary to synchronize access to this file. 
	//lock (Session.SyncRoot)
	//Try to open lock file
	while (!($lockFile = @fopen($absGalleryPath . "Descriptions.lck", "w"))){
		usleep(100000);
	}

	$descriptionsPath = $absGalleryPath . "Descriptions.xml";

	//Create XML file which will keep information about files (image dimensions, description, etc). 
	//XML is used solely for brevity. In real-life application most likely you will use database instead.
	$descriptions = new DOMDocument('1.0');
	if (file_exists($descriptionsPath))
	{
		$descriptions->load($descriptionsPath);
	}
	else
	{
		$descriptions->appendChild($descriptions->createElement("files"));
	}

	$xmlFile = $descriptions->createElement("file");
	$xmlFile->setAttribute("name", $fileName);
	$xmlFile->setAttribute("width", $_POST['Width_1']);
	$xmlFile->setAttribute("height", $_POST['Height_1']);
	$xmlFile->setAttribute("handlerUrl", $_SERVER["SCRIPT_NAME"] . "?" . $_SERVER["QUERY_STRING"]);
	$descriptions->documentElement->appendChild($xmlFile);

	$descriptions->save($descriptionsPath);

	//Release lock file
	fclose($lockFile);
}

//This method verifies whether file with such name already exists 
//and if so, construct safe filename name (to avoid collision).	
function getSafeFileName($fileName)
{
	global $absGalleryPath;
	
	$newFileName = $fileName;
	$j = 1;
	while (file_exists($absGalleryPath . "/" . $newFileName))
	{
		$newFileName = $j . "_" . $fileName;
		$j = $j + 1;
	}
	return $newFileName;	
}

saveUploadedFiles();
?>