#!/usr/bin/perl

use File::Spec;
use File::Basename;
use URI::Escape;
use HTML::Entities;
use File::stat;
use Time::localtime;

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
my $galleryPath = "../Gallery/";
  
my $HTML_TEMPLATE = <<HTMLEND;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader - Uploaded Files</title>
	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		<a href="index.pl">Upload New Files</a>
	</p>
    <table cellspacing="0" rules="all" border="1" style="border-collapse:collapse;">
        <tr style="background-color:Gainsboro;font-weight:bold;">
            <td>File Name</td>
            <td>Size in Bytes</td>
            <td>Extension</td>
            <td>Last Write Time</td>
        </tr>    
        %s
	</table>
</body>
</html>
HTMLEND

my $FILE_INFO_TEMPLATE = <<HTMLEND;
<tr>
<td><a href="%s" target="_blank">%s</a></td>
<td>%s</td>
<td>%s</td>
<td>%s</td>
</tr>
HTMLEND

sub print_html {
	print "Content-Type: text/html\r\n\r\n";
	
	#Physical path to the gallery folder
	my $absGalleryPath = File::Spec->rel2abs($galleryPath);
	
	my $rows = "";
	
	my $handle;
	
	opendir($handle, $absGalleryPath);
	while (my $fileName = readdir($handle)) {
		my $filePath = File::Spec->join($absGalleryPath, $fileName);
	    $filePath =~ /\.(\w+)\s*\"*$/;
		my $fileExt = $1 ;
		if (-f $filePath) {
			$rows .= sprintf($FILE_INFO_TEMPLATE, $galleryPath . encode_file_name($fileName),
			encode_entities($fileName),
			-s $filePath,
			encode_entities($fileExt),
			encode_entities(ctime(stat($filePath)->mtime)));
		}
	}
	closedir($handle);
	
	printf $HTML_TEMPLATE, $rows;
}

sub encode_file_name {
	return 	uri_escape(shift(@_));
}

print_html();
