require 'cgi'
require 'rexml/document'


#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
$galleryPath = "../Gallery/"

def print_html()
	print "Content-Type: text/html\r\n\r\n"
	print "\r\n"
end

def save_uploaded_files()
	$absGalleryPath = File.expand_path($galleryPath)
	absThumbnailsPath = File.join($absGalleryPath, "Thumbnails")

	#First of all, clear files and data uploaded at previous time.
	
	#Delete source files.		
	Dir.foreach($absGalleryPath) {|fileName|
		filePath = File.join($absGalleryPath, fileName)
		if File.ftype(filePath) == "file" then
			File.delete(filePath)
		end
	}

	#Delete thumbnails
	Dir.foreach(absThumbnailsPath) {|fileName|
		filePath = File.join(absThumbnailsPath, fileName)
		if File.ftype(filePath) == "file" then
			File.delete(filePath)
		end
	}

	#NOTE: If you do not want to delete previously uploaded files, just 
	#remove or comment out the code above.


	#Create XML file which will keep information about files (image dimensions, description, etc). 
	#XML is used solely for brevity. In real-life application most likely you will use database instead.
	descriptions = REXML::Document.new 
	filesElem = descriptions.add_element("files")

	cgi = CGI.new()

	#Get total number of uploaded files (all files are uploaded in a single package).
	fileCount = cgi.params["FileCount"].first.read

	#This value will keep a total size of actually uploaded images. It will be displayed
	#so that you could compare how many bytes you save. 
	totalUploadedFileSize = 0

	#Iterate through uploaded data and save the original file, thumbnail, and description.
	for i in 1..fileCount.to_i
		#Get the first thumbnail and save it to disk. It stores 1200x1200 optimized image.
		thumbnail1 = cgi.params["Thumbnail1_" + i.to_s].first
		fileName = get_safe_file_name(cgi.params['FileName_' + i.to_s].first.read)
		thumbnail1TargetPath = File.join($absGalleryPath, fileName)
		file = File.open(thumbnail1TargetPath.untaint, 'wb')
		file << thumbnail1.read
		file.close

		totalUploadedFileSize += File.size(thumbnail1TargetPath)

		#Get the second thumbnail and save it to disk. It stores 120x120 preview image. 
		thumbnail2 = cgi.params["Thumbnail2_" + i.to_s].first
		thumbnail2TargetPath = File.join(absThumbnailsPath, fileName)
		File.open(thumbnail2TargetPath.untaint, 'wb') { |file| file << thumbnail2.read}

		#Save file info.
		fileElem = filesElem.add_element "file"
		fileElem.attributes["name"] = fileName
		fileElem.attributes["width"] = cgi.params["Width_" + i.to_s].first.read
		fileElem.attributes["height"] = cgi.params["Height_" + i.to_s].first.read
	end

	#Write both optimized and source file sizes for comparison.
	filesElem.attributes["totalSourceFileSize"] = cgi.params["TotalSourceFileSize"].first.read
	filesElem.attributes["totalUploadedFileSize"] = (totalUploadedFileSize / 1024).ceil

	descriptionsPath = File.join($absGalleryPath, "Descriptions.xml")
	File.open(descriptionsPath.untaint, 'w') { |file| descriptions.write file}
end

def get_safe_file_name(fileName)
	newFileName = File.basename(fileName)
	j = 1
	while FileTest.exist?(File.join($absGalleryPath, newFileName))
		newFileName = j.to_s + "_" + fileName
	end
	return newFileName
end

print_html()

save_uploaded_files()